#!/bin/bash

#This script checks if certificate is valid or invalid, and if invalid, runs the generate-self-certified-certificate-ssl.sh script which generates certificate.
TARGET="clixserver.tiss.edu"; 
DAYS=7;
echo "Checking if $TARGET expires in less than $DAYS days";
expirationdate=$(date -d "$(: | openssl s_client -connect $TARGET:443 -servername $TARGET 2>/dev/null \
                              | openssl x509 -text \
                              | grep 'Not After' \
                              |awk '{print $4,$5,$7}')" '+%s');     #storing the date of expiry of the certificate in a variable "expirationdate".
in7days=$(($(date +%s) + (86400*$DAYS)));      #storing the date of 7 days later the present date in a variable "in7days".
if [ $in7days -gt $expirationdate ]; then      #Comparing both the dates
    echo "Certificate has to be renewed. It expired on $(date -d @$expirationdate '+%Y-%m-%d'). Renewing the certificate";
    docker exec gstudio /bin/sh -c "rm -rf /etc/ssl/clixserver.tiss.edu";
    docker exec gstudio /bin/sh -c "/bin/bash /home/docker/code/scripts/generate-self-certified-certificate-ssl.sh";  #Code to run the script "generate-self-certified-certificate-ssl.sh" inside the container.
    docker exec gstudio /bin/sh -c "service nginx reload"; 
    docker restart gstudio; 
else
    echo "Certficate valid - expires on $(date -d @$expirationdate '+%Y-%m-%d')";
fi;

