#!/bin/bash

#This script checks the md5sum of the script "create_new_crt_on_expiry", runs it and also sets a cron job to run it every time the system starts.

function crt_check() {

      crt_script="create_new_crt_on_expiry";

       #code for checking the md5sum for file checksum started

       echo "File integrity check started. Please wait";

       if [ -f ${crt_script}.sh.md5sum ]; then
           echo "${crt_script}.sh.md5sum file is present ${reset}"

           if md5sum --status -c ${crt_script}.sh.md5sum && echo OK; then
              echo "File integrity check was successful ${reset}";
           else
              echo "File integrity Check Failed. Please download the correct ${crt_script}.sh file ${reset}";
              exit;
           fi
       else
           echo "${crt_script}.sh.md5sum file not present. Please Download It ${reset}";
           exit;
       fi

       #code for checking the md5sum for file checksum ended

       #code to copy create_new_crt_on_expiry.sh and schedule_crt_watch.sh to /home/core/code/scripts/
       sudo rsync -avPhz /mnt/set-clixplatform-certificate/${crt_script}.sh /home/core/code/scripts/ ;
       sudo rsync -avPhz /mnt/set-clixplatform-certificate/schedule_crt_watch.sh /home/core/code/scripts/ ;

       #Run the script create_new_crt_on_expiry.sh
       sudo bash /home/core/code/scripts/${crt_script}.sh;

       #Code to setup cron job for running the script "create_new_crt_on_expiry.sh" 5 minutes after machine starts
       echo "@reboot sleep 300 && /bin/bash /home/core/code/scripts/${crt_script}.sh > /tmp/cron-ssl.log" >> /home/core/ssl_cron;
       crontab /home/core/ssl_cron;

       #removing the file created while setting up the cron job
       rm -r /home/core/ssl_cron;

       }

crt_check | tee crt_check.log
